/*
 * defs.h
 *
 * Created: 2016-05-10 11:27:36
 *  Author: dsosnowski
 */ 


#ifndef DEFS_H_
#define DEFS_H_

#define UART_PORT				PORTD
#define UART_DDR				DDRD
#define UART_IN					PIND
#define UART_RXD_PIN			0
#define UART_TXD_PIN			1

#define GSM_PORT				PORTD
#define GSM_DDR					DDRD
#define GSM_PIN					PIND
#define GSM_STATUS				2		//active hi
#define GSM_RING				3		//active lo
#define GSM_PWRKEY				4		//active lo		

#define GSM_STATUS_GET			(GSM_PIN & (1<<GSM_STATUS))
#define GSM_RING_GET			(GSM_PIN & (1<<GSM_RING))
#define GSM_PWRKEY_GET			(GSM_PIN & (1<<GSM_PWRKEY))
#define GSM_PWRKEY_PRESS		(GSM_PORT &= ~(1<<GSM_PWRKEY))
#define GSM_PWRKEY_RELEASE		(GSM_PORT |=  (1<<GSM_PWRKEY))

#define GSM_SIM_PORT			PORTB
#define GSM_SIM_PIN				PINB
#define GSM_SIM_DETECT			0		//active lo

#define GSM_SIM_DETECT_GET		(GSM_SIM_PIN & (1<< GSM_SIM_DETECT))

#define LED_PORT				PORTD	//active hi
#define LED_DDR					DDRD
#define LEDG_PIN				5
#define LEDO_PIN				6
#define LEDR_PIN				7
 
#define LEDG_SET				(LED_PORT |=  (1<<LEDG_PIN))
#define LEDG_OFF				(LED_PORT &= ~(1<<LEDG_PIN))
#define LEDO_SET				(LED_PORT |=  (1<<LEDO_PIN))
#define LEDO_OFF				(LED_PORT &= ~(1<<LEDO_PIN))
#define LEDR_SET				(LED_PORT |=  (1<<LEDR_PIN))
#define LEDR_OFF				(LED_PORT &= ~(1<<LEDR_PIN))

#define OUT_PORT				PORTC
#define OUT_DDR					DDRC
#define OUT_PIN					PINC
#define OUT1_PIN				1
#define OUT2_PIN				0

#define OUT1_SET				(OUT_PORT |=  (1<<OUT1_PIN))
#define OUT1_OFF				(OUT_PORT &= ~(1<<OUT1_PIN))
#define OUT2_SET				(OUT_PORT |=  (1<<OUT2_PIN))
#define OUT2_OFF				(OUT_PORT &= ~(1<<OUT2_PIN))

#define OUT1_GET				(OUT_PIN & (1<<OUT1_PIN))
#define OUT2_GET				(OUT_PIN & (1<<OUT2_PIN))

#define INPUT_PORT				PORTC
#define INPUT_DDR				DDRC
#define INPUT_PIN				PINC
#define SWITCH1_PIN				2
#define SWITCH2_PIN				3
#define ALARM1_PIN				4
#define ALARM2_PIN				5

#define SWITCH1_GET				(INPUT_PIN & (1<<SWITCH1_PIN))
#define SWITCH2_GET				(INPUT_PIN & (1<<SWITCH2_PIN))
#define ALARM1_GET				(INPUT_PIN & (1<<ALARM1_PIN))
#define ALARM2_GET				(INPUT_PIN & (1<<ALARM2_PIN))

#define FACTORY_PORT			PORTB
#define FACTORY_DDR				DDRB
#define FACTORY_PIN				PINB
#define FACTORY_RESET_PIN		3
#define FACTORY_RESET_GET		(FACTORY_PIN & (1<<FACTORY_RESET_PIN))

#define MAIN_DELAY				30 
#define MAIN_LED_PULSE			5
#define MAIN_LED_PERIOD			(2000/MAIN_DELAY)

#endif /* DEFS_H_ */